## ros-galactic-rcpputils 2.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcpputils)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # enables building a static library but later link it into a dynamic library
  add_compile_options(-fPIC)
endif()
if(NOT WIN32)
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

include_directories(include)

ament_export_include_directories(include)

add_library(${PROJECT_NAME}
  src/asserts.cpp
  src/filesystem_helper.cpp
  src/find_library.cpp
  src/get_env.cpp
  src/shared_library.cpp)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "RCPPUTILS_BUILDING_LIBRARY")
endif()
ament_target_dependencies(${PROJECT_NAME} rcutils)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(rcutils)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)

  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wthread-safety -Werror)
  endif()

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(test_asserts_ndebug test/test_asserts.cpp)
  target_link_libraries(test_asserts_ndebug ${PROJECT_NAME})

  if(TARGET test_asserts_ndebug)
    target_compile_definitions(test_asserts_ndebug PUBLIC NDEBUG)
  endif()

  ament_add_gtest(test_asserts_debug test/test_asserts.cpp)
  target_link_libraries(test_asserts_debug ${PROJECT_NAME})

  ament_add_gtest(test_thread_safety_annotations test/test_thread_safety_annotations.cpp)

  ament_add_gtest(test_join test/test_join.cpp)

  ament_add_gtest(test_get_env test/test_get_env.cpp
    ENV
      EMPTY_TEST=
      NORMAL_TEST=foo
  )
  ament_target_dependencies(test_get_env rcutils)
  target_link_libraries(test_get_env ${PROJECT_NAME})

  ament_add_gtest(test_scope_exit test/test_scope_exit.cpp)
  target_link_libraries(test_scope_exit ${PROJECT_NAME})

  ament_add_gtest(test_split test/test_split.cpp)

  ament_add_gtest(test_filesystem_helper test/test_filesystem_helper.cpp
    ENV
      EXPECTED_WORKING_DIRECTORY=$<SHELL_PATH:${CMAKE_CURRENT_BINARY_DIR}>
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  ament_target_dependencies(test_filesystem_helper rcutils)
  target_link_libraries(test_filesystem_helper ${PROJECT_NAME})

  ament_add_gtest(test_find_and_replace test/test_find_and_replace.cpp)

  ament_add_gtest(test_pointer_traits test/test_pointer_traits.cpp)

  ament_add_gtest(test_process test/test_process.cpp)
  ament_target_dependencies(test_process rcutils)

  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

  ament_add_gtest(test_shared_library test/test_shared_library.cpp
    APPEND_LIBRARY_DIRS "${append_library_dirs}"
  )

  if(TARGET test_shared_library)
    add_library(dummy_shared_library test/dummy_shared_library/dummy_shared_library.c)
    if(WIN32)
      # Causes the visibility macros to use dllexport rather than dllimport
      # which is appropriate when building the dll but not consuming it.
      target_compile_definitions(dummy_shared_library PRIVATE "DUMMY_SHARED_LIBRARY_BUILDING_DLL")
    endif()
    target_link_libraries(test_shared_library ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_endian test/test_endian.cpp)

  add_library(test_library SHARED test/test_library.cpp)
  ament_add_gtest(test_find_library test/test_find_library.cpp)
  target_link_libraries(test_find_library ${PROJECT_NAME} test_library)
  set_tests_properties(test_find_library PROPERTIES
    ENVIRONMENT
      "_TEST_LIBRARY_DIR=$<TARGET_FILE_DIR:test_library>;_TEST_LIBRARY=$<TARGET_FILE:test_library>")

  ament_add_gtest(test_clamp test/test_clamp.cpp)

  ament_add_gtest(test_accumulator test/test_accumulator.cpp)
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-galactic-rcpputils (2.2.2-1focal) focal; urgency=high

  * Add missing cstddef include (#148 <https://github.com/ros2/rcpputils/issues/148>)
  * Contributors: Octogonapus

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 02 Dec 2022 08:00:00 -0000

ros-galactic-rcpputils (2.2.1-1focal) focal; urgency=high

  * migrate rolling mean from ros2_controllers to rcppmath (backport #133 <https://github.com/ros2/rcpputils/issues/133>) (#143 <https://github.com/ros2/rcpputils/issues/143>)
  * Contributors: mergify[bot]

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 07 Jan 2022 08:00:00 -0000

ros-galactic-rcpputils (2.2.0-1focal) focal; urgency=high

  * Update quality declaration links (#130 <https://github.com/ros2/rcpputils/issues/130>)
  * Add functions for getting library path and filename (#128 <https://github.com/ros2/rcpputils/issues/128>)
  * Contributors: Nikolai Morin, Simon Honigmann

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 02 Apr 2021 07:00:00 -0000

ros-galactic-rcpputils (2.1.0-1focal) focal; urgency=high

  * Add path equality operators (#127 <https://github.com/ros2/rcpputils/issues/127>)
  * Add create_temp_directory filesystem helper (#126 <https://github.com/ros2/rcpputils/issues/126>)
  * Use new noexcept specifier. (#123 <https://github.com/ros2/rcpputils/issues/123>)
  * Contributors: Chen Lihui, Emerson Knapp

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 01 Mar 2021 08:00:00 -0000

ros-galactic-rcpputils (2.0.4-1focal) focal; urgency=high

  * Add stream operator for paths to make it easier to log (#120 <https://github.com/ros2/rcpputils/issues/120>)
  * Path join operator is const (#119 <https://github.com/ros2/rcpputils/issues/119>)
  * No windows.h in header files (#118 <https://github.com/ros2/rcpputils/issues/118>)
  * Fix rcpputils::SharedLibrary tests. (#117 <https://github.com/ros2/rcpputils/issues/117>)
  * Contributors: Emerson Knapp, Ivan Santiago Paunovic, Michel Hidalgo

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rcpputils (2.0.3-1focal) focal; urgency=high

  * Update QD to QL 1 (#114 <https://github.com/ros2/rcpputils/issues/114>)
  * Make sure to not try to index into an empty path. (#113 <https://github.com/ros2/rcpputils/issues/113>)
  * Contributors: Chris Lalancette, Stephen Brawner

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 08 Dec 2020 08:00:00 -0000

ros-galactic-rcpputils (2.0.2-1focal) focal; urgency=high

  * Fix working with filesystem parent paths. (#112 <https://github.com/ros2/rcpputils/issues/112>)
  * Cleanup mislabeled BSD license (#37 <https://github.com/ros2/rcpputils/issues/37>)
  * overload functions for has_symbol and get_symbol with raw string literal (#110 <https://github.com/ros2/rcpputils/issues/110>)
  * Add an ASSERT to the pointer traits tests. (#111 <https://github.com/ros2/rcpputils/issues/111>)
  * replace custom get env login into rcutils_get_env(). (#99 <https://github.com/ros2/rcpputils/issues/99>)
  * Removed Github Actions (#105 <https://github.com/ros2/rcpputils/issues/105>)
  * Update the package.xml files with the latest Open Robotics maintainers (#102 <https://github.com/ros2/rcpputils/issues/102>)
  * Contributors: Alejandro Hernández Cordero, Chen Lihui, Chris Lalancette, Michael Jeronimo, Tully Foote, tomoya

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 16 Nov 2020 08:00:00 -0000

ros-galactic-rcpputils (2.0.1-1focal) focal; urgency=high

  * Make sure that an existing path is a directory for create_directories (#98 <https://github.com/ros2/rcpputils/issues/98>)
  * Transfer ownership to Open Robotics (#100 <https://github.com/ros2/rcpputils/issues/100>)
  * Ensure -fPIC is used when building a static lib (#93 <https://github.com/ros2/rcpputils/issues/93>)
  * Contributors: Christophe Bedard, Dirk Thomas, Louise Poubel, William Woodall

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 05 Oct 2020 07:00:00 -0000

ros-galactic-rcpputils (2.0.0-1focal) focal; urgency=high

  * Removed doxygen warnings (#86 <https://github.com/ros2/rcpputils/issues/86>) (#87 <https://github.com/ros2/rcpputils/issues/87>)
  * Add clamp header (#85 <https://github.com/ros2/rcpputils/issues/85>)
  * Removed doxygen warnings (#86 <https://github.com/ros2/rcpputils/issues/86>)
  * Split get_env_var() into header and implementation (#83 <https://github.com/ros2/rcpputils/issues/83>)
  * Add cstring include for strcmp (#81 <https://github.com/ros2/rcpputils/issues/81>)
  * filesystem helpers: adding remove_all to remove non-empty directories (#79 <https://github.com/ros2/rcpputils/issues/79>)
  * Contributors: Alejandro Hernández Cordero, Christophe Bedard, Hunter L. Allen, Karsten Knese, Victor Lopez

 -- Emerson Knapp <eknapp@amazon.com>  Tue, 21 Jul 2020 07:00:00 -0000

ros-galactic-rcpputils (1.2.0-1focal) focal; urgency=high

  * Add scope_exit helper (#78 <https://github.com/ros2/rcpputils/issues/78>)
  * Bump setup-ros to 0.0.23, action-ros-lint to 0.0.6, action-ros-ci to 0.0.17 (#77 <https://github.com/ros2/rcpputils/issues/77>)
  * Contributors: Devin Bonnie, Michel Hidalgo

 -- Emerson Knapp <eknapp@amazon.com>  Fri, 26 Jun 2020 07:00:00 -0000

ros-galactic-rcpputils (1.1.0-1focal) focal; urgency=high

  * Fix parent_path() for empty paths and paths of length one (#73 <https://github.com/ros2/rcpputils/issues/73>)
  * Add get_executable_name() function (#70 <https://github.com/ros2/rcpputils/issues/70>)
  * Address memory leak in remove pointer test (#72 <https://github.com/ros2/rcpputils/issues/72>)
  * Add current_path to filesystem_helpers (#63 <https://github.com/ros2/rcpputils/issues/63>)
  * Align path combine behavior with C++17 (#68 <https://github.com/ros2/rcpputils/issues/68>)
  * Update quality declaration to QL 2 (#71 <https://github.com/ros2/rcpputils/issues/71>)
  * Contributors: Jacob Perron, Scott K Logan, Stephen Brawner



=== debian/control ===
Source: ros-galactic-rcpputils
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gtest <!nocheck>, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-rcutils, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rcpputils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-rcutils, ros-galactic-ros-workspace
Description: Package containing utility code for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rcpputils//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
